#COMPILE EXE
#DIM ALL
#INCLUDE "win32api.inc"
#INCLUDE "exiftool_functions.inc"
#INCLUDE "MD5.INC"


%IDC_TEXTBOX1 = 121



GLOBAL oldProc AS LONG

'====================================================================
FUNCTION PBMAIN()AS LONG
   LOCAL hDlg AS LONG
   LOCAL dwRC AS DWORD
   LOCAL dwFont AS DWORD

   ' Start the exiftool process
   dwRC = Init_exiftool()

   IF dwRC <> %TRUE THEN
      MessageBox(%NULL,"Child process exiftool failed to initialize","Error starting exiftool",%MB_OK)
      FUNCTION = %FALSE
      EXIT FUNCTION
   END IF

   DIALOG NEW 0,"Drag and drop file(s) or folder(s) to see any supported meta data",,, 800, 600, %WS_SYSMENU OR %WS_CAPTION, TO hDlg

   CONTROL ADD TEXTBOX, hDlg, %IDC_TEXTBOX1, "", 5,  5, 790, 590, %WS_VSCROLL OR %ES_MULTILINE, %WS_EX_ACCEPTFILES

   ' Use a fixed width font
   FONT NEW "COURIER" TO dwFont
   CONTROL SET FONT hDlg, %IDC_TEXTBOX1, dwFont

   DIALOG SHOW MODAL hDlg, CALL DlgProc

   FONT END  dwFont

   'Close exiftool
   WriteToPipe("-stay_open" + $CRLF)
   WriteToPipe("False" + $CRLF)

   SLEEP 2000

   CloseHandle(hChildStdInRead)
   CloseHandle(hChildStdInWrite)
   CloseHandle(hChildStdOutRead)
   CloseHandle(hChildStdOutWrite)
   CloseHandle(hChildStdErrRead)
   CloseHandle(hChildStdErrWrite)

END FUNCTION

'------------------------------------------------------------------------------

CALLBACK FUNCTION DlgProc
  SELECT CASE CBMSG
  CASE %WM_INITDIALOG
      ' oldProc will be same for all standard controls of same class, so..
      oldProc = SetWindowLong(GetDlgItem(CB.HNDL, %IDC_TEXTBOX1), %GWL_WNDPROC, CODEPTR(DragDropProc))
  END SELECT

END FUNCTION

'------------------------------------------------------------------------------

CALLBACK FUNCTION DragDropProc
  LOCAL c AS LONG, zFile AS ASCIIZ * 260, sMetaData AS STRING
  LOCAL FN AS STRING
  LOCAL MD5 AS STRING
  LOCAL TEMP_STRING AS STRING

  LOCAL TEMP_LONG AS LONG
  TEMP_LONG = CB.MSG


  SELECT CASE AS LONG CB.MSG

  CASE %WM_DROPFILES

  CASE %WM_DROPFILES
      c = DragQueryFile (CB.WPARAM, -1, BYVAL 0, 0)
      FOR c = 0 TO c - 1 ' if several files were dropped
          DragQueryFile CB.WPARAM, c, zFile, SIZEOF(zFile)
          WriteToPipe(zFile + $CRLF)
          FN = zFile
          MD5 = GET_MD5_FROM_FULL_FILE_NAME(FN)
      NEXT
      WriteToPipe("-execute" + $CRLF)
      sMetaData = ReadFromPipe() 'ExifTool Version Number         :

      TEMP_STRING = "MD5                             :"  + MD5 +  $CRLF + sMetaData
      SetWindowText CB.HNDL, BYVAL STRPTR(TEMP_STRING)
      DragFinish CB.WPARAM

  END SELECT

  FUNCTION = CallWindowProc(oldProc, CB.HNDL, CB.MSG, CB.WPARAM, CB.LPARAM)
END FUNCTION

'------------------------------------------------------------------------------

FUNCTION DisplayError(sErrMsg AS STRING,BYVAL LastError AS DWORD) AS LONG

   ' Format a readable error message and display a message box
   LOCAL pzMessage AS ASCIIZ POINTER

   FormatMessage(%FORMAT_MESSAGE_ALLOCATE_BUFFER OR _
                 %FORMAT_MESSAGE_FROM_SYSTEM OR _
                 %FORMAT_MESSAGE_IGNORE_INSERTS, _
                 BYVAL %NULL,LastError,MAKELANGID(%LANG_NEUTRAL,%SUBLANG_DEFAULT), _
                 BYVAL VARPTR(pzMessage),0,BYVAL %NULL )

   sErrMsg += " failed with error" + STR$(LastError) + $CRLF + @pzMessage
   LocalFree(pzMessage)
   MessageBox(%NULL,BYVAL STRPTR(sErrMsg),"Error",%MB_OK)

END FUNCTION

'------------------------------------------------------------------------------
